
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity bcd_counter is
    Port ( CLK : in std_logic;
           -- CE  : in std_logic;
			  RESET : in std_logic;
           OUT_BUS : out std_logic_vector(3 downto 0);
			  CARRY_OUT : out std_logic
			);
end bcd_counter;

architecture Behavioral of bcd_counter is
--   signal block_carry: std_logic;
begin
	process (CLK, RESET)
		variable Citej : integer range 0 to 10; 
   begin
		if RESET='1' then 
			Citej := 0;
			OUT_BUS <= conv_std_logic_vector(0, OUT_BUS'length); 
			CARRY_OUT <= '0';
		elsif CLK='1' and CLK'event then			
			Citej := Citej + 1;
         CARRY_OUT <= '0';
			if Citej > 9 then
				Citej := 0;	
            CARRY_OUT <= '1';
			end if; 
			OUT_BUS <= conv_std_logic_vector(Citej, OUT_BUS'length); 
		end if;
	end process;
end Behavioral;





